/*
Created by: X
http://www.createdbyx.com/

xGameConsoleXNA is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System.Diagnostics;
//using System.Data;
using System.Collections;
using System.Collections.Generic;
using System;

namespace xGameConsoleXNA
{
    /// <summary>
    /// A class for handling print events.
    /// </summary>
    public class PrintEventArgs : System.ComponentModel.CancelEventArgs
    {

        /// <summary>
        /// Stores the printed text.
        /// </summary>
        protected string mstrText = string.Empty;

        /// <summary>
        /// Gets/Sets the printed text.
        /// </summary>
        public string Text
        {
            get { return mstrText; }
            set { mstrText = value; }
        }

        /// <summary>
        /// PrintEventArgs constructor.
        /// </summary>
        public PrintEventArgs()
        {
        }

        /// <summary>
        /// PrintEventArgs constructor.
        /// </summary>
        /// <param name="Cancel">Sets the value if the Cancel property.</param>
        public PrintEventArgs(bool Cancel)
        {
            this.Cancel = Cancel;
        }

        /// <summary>
        /// PrintEventArgs constructor.
        /// </summary>
        /// <param name="Text">The text that is or was printed.</param>
        public PrintEventArgs(string Text)
        {
            this.Text = Text;
        }

        /// <summary>
        /// PrintEventArgs constructor.
        /// </summary>
        /// <param name="Cancel">Sets the value if the Cancel property.</param>
        /// <param name="Text">The text that is or was printed.</param>
        public PrintEventArgs(bool Cancel, string Text)
        {
            this.Cancel = Cancel;
            this.Text = Text;
        }
    }
}
