/*
Created by: X
http://www.createdbyx.com/

xGameConsoleXNA is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System.Diagnostics;
//using System.Data;
using System.Collections;
using System.Collections.Generic;
using System;

namespace xGameConsoleXNA
{
    /// <summary>
    /// A class for handling entry line events.
    /// </summary>
    public class ProcessEntryLineEventArgs : System.ComponentModel.CancelEventArgs
    {

        /// <summary>
        /// Stores the text from the entry line.
        /// </summary>
        protected string mstrText = string.Empty;

        /// <summary>
        /// Gets/Sets the text from the entry line.
        /// </summary>
        public string Text
        {
            get { return mstrText; }
            set { mstrText = value; }
        }

        /// <summary>
        /// ProcessEntryLineEventArgs constructor.
        /// </summary>
        public ProcessEntryLineEventArgs()
        {    
        }

        /// <summary>
        /// ProcessEntryLineEventArgs constructor.
        /// </summary>
        /// <param name="Cancel">Sets the value if the Cancel property.</param>
        public ProcessEntryLineEventArgs(bool Cancel)
        {
            this.Cancel = Cancel;
        }

        /// <summary>
        /// ProcessEntryLineEventArgs constructor.
        /// </summary>
        /// <param name="Text">The text from the entry line.</param>
        public ProcessEntryLineEventArgs(string Text)
        {
            this.Text = Text;
        }

        /// <summary>
        /// ProcessEntryLineEventArgs constructor.
        /// </summary>
        /// <param name="Cancel">Sets the value if the Cancel property.</param>
        /// <param name="Text">The text from the entry line.</param>
        public ProcessEntryLineEventArgs(bool Cancel, string Text)
        {
            this.Cancel = Cancel;
            this.Text = Text;
        }
    }

}
