/*
Created by: X
http://www.createdbyx.com/

xGameConsoleXNA is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System.Diagnostics;
//using System.Data;
using System.Collections;
using System.Collections.Generic;
using System;

namespace xGameConsoleXNA
{
    /// <summary>
    /// Provides a class that can be applied as a attribute to a method for hiding commands from users.
    /// </summary>
    public class VisibleToUsers : Attribute
    {

        private bool mblnVisible = true;

        /// <summary>
        /// If true the command will be hidden from console users.
        /// </summary>
        public bool Visible
        {
            get { return mblnVisible; }
        }

        /// <summary>
        /// VisibleToUsers constructor.
        /// </summary>
        /// <param name="Visible">Sets initial value of the <see cref="Visible"/> property.</param>
        public VisibleToUsers(bool Visible)
        {
            mblnVisible = Visible;
        }
    }

}
