/*
Created by: X
http://www.createdbyx.com/
*/
using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;


namespace xGameConsoleXNA_Example3
{
    public class CustomCommands : xGameConsoleXNA.BaseCommands
    {
        private Game1 game;

        public CustomCommands(Game1 g, xGameConsoleXNA.Console console)
            : base(console)
        {
            this.game = g;
        }

        #region " Commands ... "
        [Category("Example"), Description("Quits the applicaion/game.")]
        private string DoQuit(string[] args, bool usedAsFunction)
        {
            // exit the app.
            this.game.Exit();

            // return an empty string
            return string.Empty;
        }

        [Category("Example"), Description("Toggles wordwrap on and off.")]
        private string ToggleWordWrap(string[] args, bool usedAsFunction)
        {
            // get the console service
            xGameConsoleXNA.ConsoleComponent console;
            console = (xGameConsoleXNA.ConsoleComponent)this.game.Services.GetService(typeof(xGameConsoleXNA.ConsoleComponent));

            // toggle the word srap state is not used as like a function
            if (!usedAsFunction) console.WordWrap = !console.WordWrap;

            // return an empty string
            return usedAsFunction ? console.WordWrap.ToString() : string.Empty;
        }

        [Category("Example"), Description("Toggles full screen mode on and off.")]
        private string ToggleFullScreen(string[] args, bool usedAsFunction)
        {
            // get the console service
            GraphicsDeviceManager graphics;
            graphics = (GraphicsDeviceManager)this.game.Services.GetService(typeof(GraphicsDeviceManager));

            // toggle the word srap state is not used as like a function
            if (!usedAsFunction) graphics.ToggleFullScreen();

            // return an empty string
            return usedAsFunction ? graphics.IsFullScreen.ToString() : string.Empty;
        }

        [Category("Example"), Description("Returns a begin fuction string.")]
        private string BeginFunction(string[] args, bool usedAsFunction)
        {
            return this.CommandManager.StartFunction;
        }

        [Category("Example"), Description("Toggles full screen mode on and off.")]
        private string EndFunction(string[] args, bool usedAsFunction)
        {
            return this.CommandManager.EndFunction;
        }
        #endregion


        public override void OnConnect(xGameConsoleXNA.CommandManager Manager, xGameConsoleXNA.CommandExtenderManager ExtenderManager)
        {
            // be sire to call the base OnConnect method
            base.OnConnect(Manager, ExtenderManager);
            // add a quit command
            DoAddCommand("quit", new xGameConsoleXNA.CommandCallback(this.DoQuit));
            DoAddCommand("wordwrap", new xGameConsoleXNA.CommandCallback(this.ToggleWordWrap));
            DoAddCommand("fullscreen", new xGameConsoleXNA.CommandCallback(this.ToggleFullScreen));
            DoAddCommand("bf", new xGameConsoleXNA.CommandCallback(this.BeginFunction));
            DoAddCommand("ef", new xGameConsoleXNA.CommandCallback(this.EndFunction));
        }
    }
}
